/* Ellipse_7.pde

Written by: Marvin C. Jones and Richard (Rick) G. Freedman

Variables can hold more than just integers, they can also hold lists of integers 
and many other types of data.  Let us use a list of integers to program a simple 
animation!  We will use the list we created in Ellipse_6.pde to move the circle.
*/

//We declare the variables we will use in the program at the beginning
//The variable named arrayList stores a list (called an array []) of integers (int)
int[] arrayList;
//The variables called x and y each store an integer (int)
int x;
int y;

//We will use a variable called counter to count which item in the list we will 
//  use for the next movement in the animation
int counter;

void setup()
{
  //Set the window's size to 500 pixels wide and 300 pixels tall
  size(500, 300);
  //Perform draw() five times per second
  frameRate(5);
  
  //The equals sign (=) tells the program to store a value in a variable
  //  The array needs to know how many numbers are in its list - let's use 5
  arrayList = new int[5];

  //Now we can store a value at each item in this list
  //  Notice that the brackets are now on the side with the name of the array
  //NOTE: We begin counting items in an array at 0 instead of 1
  arrayList[0] = -10;
  arrayList[1] = 40;
  arrayList[2] = -50;
  arrayList[3] = 20;
  arrayList[4] = 80; 

  //We will begin the counter at the first item in the array
  counter = 0;

  //We will store the number 100 in each variable x and y
  x = 100;
  y = 100;
}

void draw()
{
  //This will erase everything currently drawn in the pop-up window
  clear();
   
  //Use the color purple when drawing shapes on the screen
  fill(125,0,125);
  //We will draw a circle at the location according to the values stored by our 
  //  variables (we set x and y in setup(), but now we change them at the end of
  //  draw())
  ellipse(x, y, 50, 50);  

  //Use the counter-th value in the list to change the values of x and y
  //  This will change the circle's position when draw() is performed next time
  x = x + arrayList[counter];
  y = y + arrayList[counter];

  //Move to the next item in the list   
  counter = counter + 1;
  //Start the counter over again after seeing all the items in the list
  //  The % operator takes the remainder of dividing the value in counter by 5
  counter = counter % 5;
  //NOTE: We can combine the two steps above as one command:
  //      counter = (counter + 1) % 5;
}
